#include <esp_system.h>
#include <freertos/FreeRTOS.h>
#include <freertos/task.h>
#include <bootloader_common.h>

static void set_boot_tag(uint32_t arg)
{
   const auto boot_tag = reinterpret_cast<uint32_t*>(bootloader_common_get_rtc_retain_mem()->custom + CONFIG_BOOTLOADER_CUSTOM_RESERVE_RTC_SIZE - 4);
   *boot_tag = arg;
   bootloader_common_update_rtc_retain_mem(nullptr, false); // updates checksum
}

extern "C"
void app_main(void)
{
   printf("************** FACTORY APP STARTED ***************\n");

   printf("booting OTA app in 15s\n");
   fflush(stdout);
   
   vTaskDelay(pdMS_TO_TICKS(15'000));
   set_boot_tag(0x4F544130);
   printf("restarting...\n");
   fflush(stdout);
   esp_restart();
}
